﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Xml;
using System.IO;

namespace NotEditor
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        string aNoty = "C:/mladez/velke/png/";

        private void Form1_Load(object sender, EventArgs e)
        {

            if (!Directory.Exists(aNoty))
                aNoty = "noty/";

            if (!Directory.Exists(aNoty))
            {
                MessageBox.Show("Nemůžu najít adresář s notami :'-(");
                    // Nikdo ale nemůže říci, že jsem se nesnažil.
                this.Close();
                return;
            }

            vykresliOsnovu();
        }

        Skladba oS;

        private void načístToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openFileDialog1.CheckFileExists = true;
            openFileDialog1.Filter = "XML dokument|*.xml";
            openFileDialog1.ShowDialog();

            XmlDocument xD = new XmlDocument(); // TODO: Proudové čtení! K čemu je mi negenerovat monstrózní obrázek,
                                                // když stejně načítám celou definici do paměti?
            try
            {
                xD.Load(openFileDialog1.FileName);
            }
            catch
            {
                MessageBox.Show("XML dokument není well-formed a/nebo to není XML dokument.");
                    // Politicky korektní hláška. Jasně že když to není well-formed, tak je to stejně tak XML jako PNG.
                return;
            }

            Skladba S = new Skladba();
            try
            {
                S.Takt = Convert.ToInt32(xD.DocumentElement.Attributes["takt"].Value[0].ToString());
                foreach (XmlNode xN in xD.DocumentElement.ChildNodes)
                    if (xN.Name == "nota")
                    {
                        if (xN.Attributes["delka"] == null || xN.Attributes["vyska"] == null)
                            continue;
                        Nota n = new Nota();
                        try
                        {
                            n.Délka = Convert.ToSingle(xN.Attributes["delka"].Value.Replace('.', ','));
                        }
                        catch
                        {
                            n.Délka = Convert.ToSingle(xN.Attributes["delka"].Value.Replace(',', '.'));
                        }
                        n.Výška = xN.Attributes["vyska"].Value;
                        S.Obsah.Add(n);
                    }
                    else if (xN.Name == "pomlka")
                    {
                        if (xN.Attributes["delka"] == null)
                            continue;
                        Pomlka p = new Pomlka();
                        try // Zajímavá část programu. Nepamatuju si, jak Frameworku říct, že chci používat
                        {   // anglickou kulturu číslíček. Zároveň však nevím, jestli to nebude hodnoceno
                            // na počítačích s nastavenou angličtinou. Tak to zkusím dvakrát, jednou to vyjít musí.
                            p.Délka = Convert.ToSingle(xN.Attributes["delka"].Value.Replace('.', ','));
                        }
                        catch
                        {
                            p.Délka = Convert.ToSingle(xN.Attributes["delka"].Value.Replace(',', '.'));
                        }
                        S.Obsah.Add(p);
                    }
            }
            catch
            {
                MessageBox.Show("XML to sice je, ale nemá data ve správném formátu.");
                return;
            }

            P = 0;
            oS = S;
            vykresliSkladbu();
        }

        private void uložitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (oS == null)
            {
                MessageBox.Show("Není co ukládat. Otevřte nejprve něco!");
                return;
            }

            saveFileDialog1.Filter = "XML dokument|*.xml";
            saveFileDialog1.CheckFileExists = false;
            saveFileDialog1.CheckPathExists = true;
            saveFileDialog1.ShowDialog();

            if (string.IsNullOrEmpty(saveFileDialog1.FileName))
                return;

            XmlDocument xD = new XmlDocument();
            XmlElement xE = xD.CreateElement("skladba"); // Nuda, nuda, šeď, šeď, v C# 3.0 půjdou XML soubory díky XLinqu vyrábět lépe a radostněji.
            xE.Attributes.Append(xD.CreateAttribute("takt")).Value = oS.Takt.ToString() + "/4";
            foreach (Něco n in oS.Obsah)
                if (n is Nota)
                {
                    XmlElement xE2 = xD.CreateElement("nota");
                    xE2.Attributes.Append(xD.CreateAttribute("delka")).Value = ((Nota)n).Délka.ToString().Replace(',','.');
                    xE2.Attributes.Append(xD.CreateAttribute("vyska")).Value = ((Nota)n).Výška;
                    xE.AppendChild(xE2);
                }
                else if (n is Pomlka)
                {
                    XmlElement xE2 = xD.CreateElement("pomlka");
                    xE2.Attributes.Append(xD.CreateAttribute("delka")).Value = ((Pomlka)n).Délka.ToString().Replace(',', '.');
                    xE.AppendChild(xE2);
                }
            xD.AppendChild(xE);
            xD.Save(saveFileDialog1.FileName);
        }

        void vykresliOsnovu()
        {
            Bitmap B = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics G = Graphics.FromImage(B);

            for (int i = 0; i < 5; i++)
                G.DrawLine(new Pen(Color.Black, 2), 0, 11 * (i+1), B.Width, 11 * (i+1));

            pictureBox1.Image = B;
        }

        int P = 0;
        int padding = 5;

        void vykresliSkladbu()
        {
            vyčisti();

            int teďJsem = 0;

            //MessageBox.Show(P.ToString());
            int zP = P;
            if (P == 0)
            {
                // Vykreslení notového klíče.
                PictureBox p = new PictureBox();
                p.Image = Image.FromFile(aNoty + "klic.png");
                p.SizeMode = PictureBoxSizeMode.AutoSize;
                p.Top = 36;
                p.Left = pictureBox1.Left + padding + teďJsem;
                Controls.Add(p);
                teďJsem += padding + p.Image.Width;

                // Vykreslení té věci vedle notového klíče.
                PictureBox p2 = new PictureBox();
                p2.Image = Image.FromFile(aNoty + "takt_" + oS.Takt + ".png");
                p2.SizeMode = PictureBoxSizeMode.AutoSize;
                p2.Top = 56;
                p2.Left = pictureBox1.Left + padding + teďJsem;
                Controls.Add(p2);
                teďJsem += padding + p2.Image.Width;
            }

            float vTaktuZbývá = oS.Takt; // Ne že bych tuhle proměnou byl někdy použil. Ale už tu jednou je a nikomu nevadí.
            while (P < oS.Obsah.Count)
            {
                float d = 0;
                if (oS.Obsah[P] is Nota)
                {
                    Nota n = (Nota)(oS.Obsah[P]);
                    d = n.Délka;

                    while (d >= 4)
                    {
                        přikresliNotu(4, n.Výška, ref teďJsem);
                        d -= 4;
                    }
                    if (teďJsem > pictureBox1.Width)
                    {
                        pictureBox1.SendToBack();
                        return;
                    }
                    if (d >= 2)
                    {
                        přikresliNotu(2, n.Výška, ref teďJsem);
                        d -= 2;
                    }
                    if (teďJsem > pictureBox1.Width)
                    {
                        pictureBox1.SendToBack();
                        return;
                    }
                    if (d >= 1)
                    {
                        přikresliNotu(1, n.Výška, ref teďJsem);
                        d -= 1;
                    }
                    if (teďJsem > pictureBox1.Width)
                    {
                        pictureBox1.SendToBack();
                        return;
                    }
                    if (d >= 0.5)
                    {
                        přikresliNotu(0.5F, n.Výška, ref teďJsem);
                        d -= 0.5F;
                    }
                    if (teďJsem > pictureBox1.Width)
                    {
                        pictureBox1.SendToBack();
                        return;
                    }
                }
                else if (oS.Obsah[P] is Pomlka)
                {
                    Pomlka p = (Pomlka)(oS.Obsah[P]);
                    d = p.Délka;

                    Image o = dejSemObrázekPomlky(p.Délka);
                    if (o.Width + teďJsem > pictureBox1.Width)
                    {
                        pictureBox1.SendToBack();
                        return;
                    }
                    PictureBox pic = new PictureBox();
                    pic.Image = o;
                    pic.Left = pictureBox1.Left + padding + teďJsem;
                    teďJsem += o.Width + padding;
                    pic.Top = 35;
                    pic.SizeMode = PictureBoxSizeMode.AutoSize;
                    Controls.Add(pic);
                }

                /*if (d == vTaktuZbývá)
                {
                    PictureBox pč = new PictureBox();
                    pč.Width = 2;
                    pč.Height = 50;
                    pč.BackColor = Color.Black;
                    pč.Left = pictureBox1.Left + padding + teďJsem;
                    pč.Top = 50;
                    teďJsem += 2;
                    Controls.Add(pč);
                    vTaktuZbývá = oS.Takt;
                }
                else
                    vTaktuZbývá -= d;*/
                P++;
            }
            P = zP;
            pictureBox1.SendToBack();
        }

        /// <summary>
        /// Tím už se myslí už rozkouskovaná nota. Přikreslení noty == přidání pictureBoxu na formulář.
        /// </summary>
        void přikresliNotu(float délka, string výška, ref int teďJsem)
        {
            Image o;
            if (délka == 0.5 || délka == 1 || délka == 2 || délka == 4)
                o = dejSemObrázekNoty(délka, výška, false);
            else
                o = dejSemObrázekNoty((délka == 3) ? 2 : 1, výška, true);
            if (o.Width + teďJsem > pictureBox1.Width)
            {
                pictureBox1.SendToBack();
                return;
            }
            PictureBox pic = new PictureBox();
            pic.Image = o;
            pic.Left = pictureBox1.Left + padding + teďJsem;
            teďJsem += o.Width + padding;
            pic.Top = 35;
            pic.SizeMode = PictureBoxSizeMode.AutoSize;
            Controls.Add(pic);
        }

        string[] noty = { "C", "Cis", "D", "Dis", "E", "F", "Fis", "G", "Gis", "A", "Ais", "H", "c", "cis", "d", "dis", "e", "f", "fis", "g", "gis", "a", "ais", "h" };
        int[] vyska = { 0, 0, 1, 1, 2, 3, 3, 4, 4, 5, 5, 6, 7, 7, 8, 8, 9, 10, 10, 11, 11, 12, 12, 13 };

        /// <param name="délka">Jenom 4, 2, 1 a 0.5!</param>
        /// <param name="výška">C, Cis, D, Dis...</param>
        /// <returns>Obrázek noty</returns>
        Image dejSemObrázekNoty(float délka, string výška, bool tečka)
        {
            int q = -1;
            for (int i = 0; i < noty.Length; i++)
                if (noty[i] == výška)
                    q = i;

            Image o = Image.FromFile(aNoty + "nota_4.png");
            if (délka != 4)
            {
                int id = 0;
                if (délka == 2)
                    id = 2;
                else if (délka == 1)
                    id = 1;

                // (tečka ? "_tecka" : "") + 
                o = Image.FromFile(aNoty + "nota_" + (výška.EndsWith("is") ? "krizek_" : "") + ((q > 11) ? "dolu_" : "nahoru_") + id + ".png");
            }

            Bitmap vysl = new Bitmap(o.Width + (tečka ? 10 : 0), 80);
            Graphics G = Graphics.FromImage(vysl);
            //G.FillRectangle(Brushes.Aqua, 0, 0, vysl.Width - 1, vysl.Height - 1);
            G.DrawImage(o, new Point(0, 55 - (int)(vyska[q] * 5.5) - ((výška.EndsWith("is") && q > 11) ? 6 : 0) + ((q > 11) ? 18 : 0)));
            doplňČáry(G, vysl); // Blbá průhlednost :-( Nefunguje mi. Musím kreslit čáry i do not, aby to nevypadalo tak moc hnusně.
            //if (tečka) G.FillEllipse(Brushes.Black, 0, 0, 5, 5);

            return vysl;
        }


        Image dejSemObrázekPomlky(float délka)
        {
            if (délka == 3) délka = 2; // Tak tohle jste neviděli.
            int č = Convert.ToInt32(délka.ToString()[0].ToString()); // :-)
            Image o = Image.FromFile(aNoty + "pomlka_" + č + ".png");

            Bitmap vysl = new Bitmap(o.Width, 80);
            Graphics G = Graphics.FromImage(vysl);
            doplňČáry(G, vysl); // Blbá průhlednost :-(
            if (č == 4)
                G.DrawImage(o, new Point(0, 31));
            else if (č == 2)
                G.DrawImage(o, new Point(0, 39));
            else if (č == 1)
                G.DrawImage(o, new Point(0, 35));
            else if (č == 0)
                G.DrawImage(o, new Point(0, 33));

            return vysl;
        }

        void doplňČáry(Graphics G, Bitmap B)
        {
            for (int i = 0; i < 5; i++)
                G.DrawLine(new Pen(Color.Black, 2), 0, 11 * (i + 1) + 10, B.Width, 11 * (i + 1) + 10);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (oS == null) return;
            if (P > 0) P--;
            vykresliSkladbu();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (oS == null) return;
            if (P < oS.Obsah.Count - 1) P++;
            vykresliSkladbu();
        }

        void vyčisti()
        {
            for (int i = 0; i < Controls.Count; i++)
                if (Controls[i] is PictureBox && (Controls[i].Tag == null || Controls[i].Tag.ToString() != "nemazat"))
                {
                    Controls.RemoveAt(i);
                    i--;
                }
        }

        private void konecToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void změnaTaktovéDélkyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Vidíte tady nějaký takty? :-)");
        }

        private void oToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Tento program se jmenuje NotEditor, protože umí uložit, co načetl, v naprosto nezměněné podobě. Aspoň doufám.");
        }
    }
}

class Skladba
{
    public int Takt;
    public List<Něco> Obsah = new List<Něco>();
}

class Něco
{ }

class Nota : Něco
{
    public float Délka;
    public string Výška;
}

class Pomlka : Něco
{
    public float Délka;
}